(* ESEMPI *)

(* ESERCIZIO 1  *)

(* funzione ausiliaria per eseguire un comando *)
let execCom (c:com) = semc(c,(emptyenv Unbound),(emptystore Undefined));;
(* val execCom : com -> mval store = <fun> *)

(* semplice blocco: { DECL: int x = 1; BODY: int y = 0; y := x } *)

let (block1:com) =   (* dichiaro il comando *)
Block([("x", Newloc (Eint 1)); ("y", Newloc (Eint 0))],   (* decl *)
  [Assign(Den "y",Val (Den "x"))]);;                 (* comandi *)

let (st: mval store) = execCom(block1);;    (* eseguo il comando *)

applystore(st, 0);;
applystore(st, 1);;
(*  - : mval = Mint 1 *)
(* - : mval = Mint 1 *)

(*  blocchi annidati : 
{ DECL: int x = 1; BODY: x := x +1; 
  	{ DECL: int y = x; BODY: x := y+1 }; 
 x:= x + 1  } *)

let (block2:com) =
Block([("x", Newloc (Eint 1))],                          (* {int x = 1; *) 
[Assign(Den "x",Sum(Val (Den "x"),Eint 1));              (* x := x +1; *)
Block ([("y", Newloc(Val(Den "x")))],                     (* {int y = x; *)
[Assign(Den "x",Sum(Val (Den "y"), Eint 1))]);              (* x := y+1 }  *)	
Assign(Den "x",Sum(Val (Den "x"), Eint 1))]);;            (* x:= x + 1  } *)

let (st2: mval store) = execCom(block2);;

applystore(st2, 0);;
applystore(st2, 1);;
(*  - : mval = Mint 4 *)
(* - : mval = Mint 2 *)

(* ESERCIZIO 2 *)

(*  invocazione di procedura semplice : 
{DECL Proc P = { DECL: int x = 1; BODY: x := x +1; 
  	{ DECL: int y = x; BODY: x := y+1 }; 
     x:= x + 1  }; 
BODY: Call P; Call P *)

let (com1:com) =
Block([("P", SimpleProc(
([("x", Newloc (Eint 1))],                          (* {int x = 1; *) 
[Assign(Den "x",Sum(Val (Den "x"),Eint 1));              (* x := x +1; *)
Block ([("y", Newloc(Val(Den "x")))],                     (* {int y = x; *)
[Assign(Den "x",Sum(Val (Den "y"), Eint 3))]);              (* x := y+1 }  *)	
Assign(Den "x",Sum(Val (Den "x"), Eint 1))])))],           (* x:= x + 1  } *)
[CallSimple(Den "P");CallSimple(Den "P")])

let (st3: mval store) = execCom(com1);;

applystore(st3, 0);;
applystore(st3, 1);;
applystore(st3, 2);;
applystore(st3, 3);;

(* - : mval = Mint 6
 - : mval = Mint 2
 - : mval = Mint 6
 - : mval = Mint 2 *)


(*  invocazione di procedura semplice con rif a ambiente non locale: 
{DECL x = 1; Proc P = { DECL:  BODY: x := x +1; 
  	{ DECL: int y = x; BODY: x := y+1 }; 
     x:= x + 1  }; 
BODY: Call P; Call P *)

let (com2:com) =
Block([("x",Newloc (Eint 1)); ("P", SimpleProc(
([],                          (* {int x = 1; *) 
[Assign(Den "x",Sum(Val (Den "x"),Eint 1));              (* x := x +1; *)
Block ([("y", Newloc(Val(Den "x")))],                     (* {int y = x; *)
[Assign(Den "x",Sum(Val (Den "y"), Eint 3))]);              (* x := y+1 }  *)	
Assign(Den "x",Sum(Val (Den "x"), Eint 1))])))],           (* x:= x + 1  } *)
[CallSimple(Den "P");CallSimple(Den "P")])

let (st4: mval store) = execCom(com2);;

applystore(st4, 0);;
applystore(st4, 1);;
applystore(st4, 2);;
applystore(st4, 3);;

(* - : mval = Mint 11
 - : mval = Mint 2
 - : mval = Mint 7
 - : mval = Undefined *)




